<template>
  <div v-if="updateExists" class="SnackUpdate">
    <span class="SnackUpdate__message">{{ t('pwa.available') }}</span>
    <Button
      :label="t('pwa.update')"
      class="SnackUpdate__button"
      @click="refreshApp"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent, inject, PropType } from 'vue'
import { States } from '@/types'
import Button from '@/components/Button.vue'

export default defineComponent({
  components: { Button },

  props: {
    pwaUpdate: {
      type: Object as PropType<States.PwaUpdate>,
      required: true,
    },
  },

  setup(props) {
    function refreshApp() {
      props.pwaUpdate.read()
      if (
        !props.pwaUpdate.registration ||
        !props.pwaUpdate.registration.waiting
      )
        return
      props.pwaUpdate.registration.waiting.postMessage({
        type: 'SKIP_WAITING',
      })
    }

    return {
      updateExists: props.pwaUpdate.updateExists,
      refreshApp,
      t: inject('t', (str: unknown) => str),
    }
  },
})
</script>

<style lang="scss" scoped>
.SnackUpdate {
  position: fixed;
  bottom: 0;
  left: 0;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  width: 100vw;
  padding: 16px;
}

.SnackUpdate__message {
  margin-right: 16px;
}
</style>
